package md

type MerchantAddReq struct {
	Name         string `json:"name" binding:"required" label:"名称"`
	EnterpriseId int    `json:"enterprise_id" binding:"required" label:"校企id"`
}

type MerchantUpdateReq struct {
	Id           int    `json:"id" binding:"required" label:"id"`
	Name         string `json:"name" binding:"required" label:"名称"`
	EnterpriseId int    `json:"enterprise_id" binding:"required" label:"校企id"`
	CreateAt     string `json:"create_at" binding:"required" label:"创建时间"`
}

type MerchantListReq struct {
	Name         string `json:"name" label:"名称"`
	EnterpriseId int    `json:"enterprise_id" label:"校企id"`
	Limit        int    `json:"limit"`
	Page         int    `json:"page" `
}
